<template>
	<SpinnerHolder v-if="loading" style="background-color: #000000"></SpinnerHolder>
	<Background v-else-if="!loading && foundRestaurant && active" class="container" :custom="true">
		<VariableLogo class="logo" :custom="true"></VariableLogo>
		<div v-if="languajeSelector" style="display: contents;">
			<LanguageSelector class="language-selector" @select="languageSelected"></LanguageSelector>
		</div>
		<div v-if="localized.length === 1">
			<h1>Cargando...</h1>
		</div>
		<img v-if="!$store.state.customBackgroundURL" class="plates" src="../assets/img/comida.png" />
	</Background>
	<div v-else-if="!active" class="inactive-service"></div>
	<div v-else class="not-found"></div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import Background from '@/components/Background.vue'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import VariableLogo from '@/components/VariableLogo.vue'
import LanguageSelector from '@/components/LanguageSelector.vue'
import MenuService from "../services/MenuService"
import Localization from '../models/Localization'
import { TypeOrder } from '@/store/state'
import { TypeView } from '@/models/Menu'

@Component({
	components: {
		Background,
		VariableLogo,
		LanguageSelector,
		SpinnerHolder
	}
})
export default class Splashscreen extends Vue {
	loading = true
	foundRestaurant = false
	languajeSelector = false;
	localized = [];
	active = true;

	async notFound() {
		this.foundRestaurant = false
		this.loading = false
	}

	async showSplashscreen() {
		const menu = this.$store.state.menu

		if (menu) {
			this.active = menu.active
			this.loading = false
			this.foundRestaurant = true

			const localizations = menu.localizations

			this.localized = menu.localizations
			if (localizations && localizations.length == 1 && this.active) {
				this.skipSplashscreen(localizations[0])
			}else{
				this.languajeSelector = true;
			}
		}
	}

	skipSplashscreen(localization: Localization){
		this.$store.dispatch('changeCurrency', localization.currency)
		this.$store.dispatch('changeLanguage', localization.language)
		this.$emit('select')
		this.languageSelected()
	}

	languageSelected() {
		this.$router.push('/menu')
	}

	async created() {

		const restaurantIdOrSlug = this.$route.params.restaurantId;
		const menuIdOrSlug: string | undefined = this.$route.params.menuId;

		await this.$store.dispatch('getRestaurant', restaurantIdOrSlug);
        await this.$store.dispatch('getMenu', menuIdOrSlug);
        await this.$store.dispatch('getDeliveryMenu', this.$store.state.menu.id);
        await this.$store.dispatch('setTypeOrder', TypeOrder.DELIVERY)
        await this.$store.dispatch('setNewOrder')

		if (!this.$store.state.restaurant || !this.$store.state.menu) {
			this.notFound()
			return
		}

        if(this.$route.query.origin == 'qr'){
            await MenuService.addView(this.$store.state.menu.id, TypeView.QR)
        }else{
            await MenuService.addView(this.$store.state.menu.id, TypeView.SHIPPING)
        }
        this.showSplashscreen()
		// setTimeout(this.showSplashscreen, 2000)
	}
}
</script>

<style lang="scss">
.black-white {
	color: #000;
	text-shadow: 2px 2px #fff;
}
.spinner-center {
	position: absolute;
	top: 50%;
	left: 45%;
}
.container {
	position: relative;
	display: flex;
	flex-direction: column;
	align-items: center;
	position: relative;
	height: 100%;
	.logo {
		width: 80%;
		max-width: 300px;
		margin-top: 5vh;
		position: relative
	}

	.description {
		color: white;
		font-weight: light;
		letter-spacing: 5px;
		margin-bottom: 5vh;
	}

	.language-selector {
		position: absolute;
		top: 50%;
		text-align: center;
		margin-left: auto;
		margin-right: auto;
	}

	.plates {
		width: 100%;
		max-width: 500px;
		position: absolute;
		bottom: 0;
		z-index: 0;
	}
}

.hidden {
	visibility: hidden;
}

.inactive-service{
	margin: 0;
	width: 100%;
	height: 100%;
	background-image: url("~@/assets/img/out-of-service.png");
	background-size: cover;
	background-repeat: no-repeat;
}

.not-found{
	margin: 0;
	width: 100%;
	height: 100%;
	background-image: url("~@/assets/img/not-found.png");
	background-size: cover;
	background-repeat: no-repeat;
}
</style>
